package dev.fyloz.colorrecipesexplorer.repository

import dev.fyloz.colorrecipesexplorer.model.Company
import dev.fyloz.colorrecipesexplorer.model.Recipe
import org.springframework.data.jpa.repository.JpaRepository

interface RecipeRepository : JpaRepository<Recipe, Long> {
    /** Checks if one or more recipes have the given [company]. */
    fun existsByCompany(company: Company): Boolean

    /** Checks if a recipe exists with the given [name] and [company]. */
    fun existsByNameAndCompany(name: String, company: Company): Boolean

    /** Gets all recipes with the given [name]. */
    fun findAllByName(name: String): Collection<Recipe>

    /** Gets all recipes with the given [company]. */
    fun findAllByCompany(company: Company): Collection<Recipe>
}
